﻿using System;
using System.Collections.Generic;
using System.Net.Security;
using System.ServiceModel;
using HeuristicLab.Services.Optimization.Billing.Model;

namespace HeuristicLab.Services.Optimization.Billing.Interfaces {
  [ServiceContract(ProtectionLevel = ProtectionLevel.EncryptAndSign)]
  public interface IOptimizationBilling {
    [OperationContract]
    IList<Product> GetProducts();
    IList<Product> GetProductByName(string productName);

    // payment methods via enumeration

    [OperationContract]
    void SaveOrder(Order order);

    [OperationContract]
    IList<Order> GetOrdersByState(OrderState state);
    IList<Order> GetOrders(string userName);
    void UpdateOrder(Order order);

    IList<Invoice> GetInvoices(string userName);

    User GetUser(string userName);
    void SaveUser(User user);

    IList<UsageRecord> GetUsageRecords(string userName);
    IList<UsageRecord> GetUsageRecords(string username, DateTime from, DateTime to);

  }
}
